part of forestvpn_api.api;

class Subscription {
  
  String subscriptionId = null;
  
  bool reorder = null;
  
  String name = null;
  
  String description = null;
  
  String bundleId = null;
  
  String productId = null;
  
  DateTime cancellationDate = null;
  
  DateTime purchaseDate = null;
  
  DateTime expiresDate = null;
  
  bool active = null;
  
  bool isTrialPeriod = null;
  
  bool isInIntroOfferPeriod = null;
  
  bool isUpgraded = null;
  
  String environment = null;
  
  String source_ = null;
  
  String promotionalOfferId = null;
  
  int qunatity = null;
  Subscription();

  @override
  String toString() {
    return 'Subscription[subscriptionId=$subscriptionId, reorder=$reorder, name=$name, description=$description, bundleId=$bundleId, productId=$productId, cancellationDate=$cancellationDate, purchaseDate=$purchaseDate, expiresDate=$expiresDate, active=$active, isTrialPeriod=$isTrialPeriod, isInIntroOfferPeriod=$isInIntroOfferPeriod, isUpgraded=$isUpgraded, environment=$environment, source_=$source_, promotionalOfferId=$promotionalOfferId, qunatity=$qunatity, ]';
  }

  Subscription.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    subscriptionId = json['subscription_id'];
    reorder = json['reorder'];
    name = json['name'];
    description = json['description'];
    bundleId = json['bundle_id'];
    productId = json['product_id'];
    cancellationDate = (json['cancellation_date'] == null) ?
      null :
      DateTime.parse(json['cancellation_date']);
    purchaseDate = (json['purchase_date'] == null) ?
      null :
      DateTime.parse(json['purchase_date']);
    expiresDate = (json['expires_date'] == null) ?
      null :
      DateTime.parse(json['expires_date']);
    active = json['active'];
    isTrialPeriod = json['is_trial_period'];
    isInIntroOfferPeriod = json['is_in_intro_offer_period'];
    isUpgraded = json['is_upgraded'];
    environment = json['environment'];
    source_ = json['source'];
    promotionalOfferId = json['promotional_offer_id'];
    qunatity = json['qunatity'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (subscriptionId != null)
      json['subscription_id'] = subscriptionId;
    if (reorder != null)
      json['reorder'] = reorder;
    if (name != null)
      json['name'] = name;
    if (description != null)
      json['description'] = description;
    if (bundleId != null)
      json['bundle_id'] = bundleId;
    if (productId != null)
      json['product_id'] = productId;
      json['cancellation_date'] = cancellationDate == null ? null : cancellationDate.toUtc().toIso8601String();
      json['purchase_date'] = purchaseDate == null ? null : purchaseDate.toUtc().toIso8601String();
      json['expires_date'] = expiresDate == null ? null : expiresDate.toUtc().toIso8601String();
    if (active != null)
      json['active'] = active;
    if (isTrialPeriod != null)
      json['is_trial_period'] = isTrialPeriod;
    if (isInIntroOfferPeriod != null)
      json['is_in_intro_offer_period'] = isInIntroOfferPeriod;
    if (isUpgraded != null)
      json['is_upgraded'] = isUpgraded;
    if (environment != null)
      json['environment'] = environment;
    if (source_ != null)
      json['source'] = source_;
    if (promotionalOfferId != null)
      json['promotional_offer_id'] = promotionalOfferId;
    if (qunatity != null)
      json['qunatity'] = qunatity;
    return json;
  }

  static List<Subscription> listFromJson(List<dynamic> json) {
    return json == null ? List<Subscription>() : json.map((value) => Subscription.fromJson(value)).toList();
  }

  static Map<String, Subscription> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, Subscription>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = Subscription.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of Subscription-objects as value to a dart map
  static Map<String, List<Subscription>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<Subscription>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = Subscription.listFromJson(value);
       });
     }
     return map;
  }
}

